<?php
/**
 * @version		$Id: submission_form.php,v 1.13 2012-01-18 17:12:32 juanca Exp $
 * @package		vpl. submission form definition
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once dirname(__FILE__).'/../locallib.php';
class mod_vpl_submission_form extends moodleform {
	protected $vpl;
	function __construct($page,$vpl){
		$this->vpl =$vpl;
		parent::__construct($page);
	}
	function definition(){
		global $CFG;
		$mform =& $this->_form;
		$mform->setMaxFileSize($this->vpl->get_maxfilesize());
		$mform->addElement('header', 'headersubmission', get_string('submission', VPL));
		//Identification info
		$mform->addElement('hidden','id');
		$mform->setType('id', PARAM_INT);
		$mform->addElement('hidden','userid',0);
		$mform->setType('userid', PARAM_INT);
		//Comments
		$mform->addElement('textarea', 'comments', get_string('comments',VPL),array('cols'=>'40', 'rows'=>2));
		$mform->setType('comments', PARAM_TEXT);

		//Files upload
		$instance = $this->vpl->get_instance();
		$files = $this->vpl->get_required_files();
		$nfiles = count($files);
		for($i = 0 ; $i < $instance->maxfiles ; $i++ ){
			$field ='file'.$i;
			if($i < $nfiles){
			   $mform->addElement('file', $field, $files[$i]);
			   $mform->addRule($field,get_string('filerequired',VPL),'uploadedfile');
			   //TODO regex for filename
			   //$mform->addRule($field,get_string('filenamerequired',VPL),'filename','\''.$files[$i].'\'');
			}
			else{
			   $mform->addElement('file', $field, get_string('anyfile',VPL));
			}
		}
		$this->add_action_buttons(TRUE,get_string('submit'));
	}
}
?>
