<?php
/**
 * @version		$Id: submissionview.php,v 1.9 2011-10-04 00:02:24 juanca Exp $
 * @package		vpl. view a submission
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../../../config.php';
global $CFG, $USER;
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/grade_form.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';
$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$course = $vpl->get_course();
$instance = $vpl->get_instance();
$userid = optional_param('userid',FALSE,PARAM_INT);
$submissionid =  optional_param('submissionid',FALSE,PARAM_INT);
//Read records
if($userid && $userid != $USER->id){
	//Grader
	$vpl->require_capability(VPL_GRADE_CAPABILITY);
	$grader =TRUE;
	if($submissionid){
		$subinstance = get_record('vpl_submissions','id',$submissionid);
	}else{
		$subinstance = $vpl->last_user_submission($userid);
	}
}
else{
	//view own submission
	$vpl->require_capability(VPL_VIEW_CAPABILITY);
	$userid = $USER->id;
	$grader = FALSE;
	if($submissionid && $vpl->has_capability(VPL_GRADE_CAPABILITY)){
		$subinstance = get_record('vpl_submissions','id',$submissionid);
	}else{
		$subinstance = $vpl->last_user_submission($userid);
	}
}
if($subinstance!=null && $subinstance->vpl != $vpl->get_instance()->id){
	print_error('invalidcourseid');
}
if($USER->id == $userid){
	$vpl->network_check();
	$vpl->password_check();
}
//Print header
$CFG->stylesheets[] = vpl_mod_href('css/sh.css');
$vpl->print_header(get_string('submissionview',VPL));
$vpl->print_view_tabs(basename(__FILE__));
//Display submission

//Check consistence
if(!$subinstance){
	notice(get_string('nosubmission',VPL),vpl_mod_href('view.php','id',$id,'userid',$userid));
}
$submissionid = $subinstance->id;

if($vpl->is_inconsistent_user($subinstance->userid,$userid)){
	print_error('vpl submission user inconsistence');
}
if($vpl->get_instance()->id != $subinstance->vpl){
	print_error('vpl submission vpl inconsistence');
}
$submission = new mod_vpl_submission($vpl,$subinstance);

if($vpl->get_instance()->visiblegrade || $vpl->has_capability(VPL_GRADE_CAPABILITY)){
	if($submission->is_graded()){
		echo '<h2>'.get_string('grade').'</h2>';
		$submission->print_grade(true);
	}
}
$vpl->print_variation( $subinstance->userid);
$submission->print_submission();
$vpl->print_footer();

?>