/**
 * @version $Id: editor.js,v 1.27 2012-03-16 15:36:03 juanca Exp $
 * @package vpl. jscript functions to manage applet editor
 * @copyright Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights
 *            reserved.
 * @license GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author Juan Carlos Rodriguez-del-Pino
 */
 
// For internationalization need the vars vpl_changesNotSaved,
// vpl_fileNotChanged,
// vpl_filesNotChanged

var vpl_fileName= new Array();
var vpl_fileData= new Array();
var vpl_NFiles=0;

/**
 * When editing some files, this function get the initial filenames and data
 * from the editor
 */
function vpl_initFiles(){
	var ae = window.document.getElementById('appleteditorid');
	if(ae != null){
		try{
			if(ae.isActive()){
				vpl_NFiles=ae.getNFiles();
				for(i=0; i<vpl_NFiles; i++){
					vpl_fileName[i]=new String(ae.getFileName(i));
					vpl_fileData[i]=new String(ae.getFileContent(i));
				}
			}
			else{
				setTimeout('vpl_initFiles()',100);				
			}
		}
		catch(e){
			setTimeout('vpl_initFiles()',250);
		}
	}else{
		setTimeout('vpl_initFiles()',100);
	}
}

/**
 * When editing one file, this function check data change
 * and set data in form fields
 */
function vpl_readFile(){
	var fm = window.document.getElementById('mform1');
	var ae = window.document.getElementById('appleteditorid');
	if(ae == null || fm == null){
		alert('VPL: readFile() javascript error');
		return false; 
	}
	try{
		newData = new String(ae.getFileContent(0));
		previousData = new String(vpl_fileData[0]);
		fm.filedata.value = newData;
		fm.fontsize.value = ae.getFontSize();
		vpl_fileData[0]=newData;
		return true;
	}
	catch(e){
		alert('VPL: readFile() javascript error: '+e);
		return false;
	}
}

/**
* This function set edit target in form (XHTML restriction)
*/
function vpl_setETarget(){
	var fm = window.document.getElementById('mform1');
	var er= window.document.getElementById('div_er');
	if(er == null || fm == null){
		alert('VPL: setETarget() javascript error');
		throw 'VPL: setETarget() javascript error'; 
	}
	fm.target='edit_result';
	er.innerHTML='<iframe name="edit_result"></iframe>';	
}

/**
* When editing files, this function check if data change
* and set data in form fields
*/
function vpl_readFiles(){
	var fm = window.document.getElementById('mform1');
	var ae = window.document.getElementById('appleteditorid');
	if(ae == null || fm == null){
		alert('VPL: vpl_readFiles() javascript error');
		return false;; 
	}
	try{
		vpl_NFiles=ae.getNFiles();
		for(i=0; i<vpl_NFiles; i++){
			newName = new String(ae.getFileName(i));
			fm.elements['filename'+i].value=newName;
			vpl_fileName[i]=newName;
			newData = new String(ae.getFileContent(i));
			fm.elements['filedata'+i].value=newData;
			vpl_fileData[i]=newData;
		}
		for(i=vpl_NFiles; i<vpl_maxFiles; i++){
			fm.elements['filename'+i].value='';
			vpl_fileName[i]='';
			fm.elements['filedata'+i].value='';
			vpl_fileData[i]='';
		}
		fm.fontsize.value = ae.getFontSize();
		return true;
	}
	catch(e){ //No access to applet
		alert('VPL: JavaScript error reading files from applet:'+e);
		return false;
	}
}

/**
* This function check if data has changed
*/
function vpl_filesChanged(){
	var fm = window.document.getElementById('mform1');
	var ae = window.document.getElementById('appleteditorid');
	if(ae == null || fm == null){
		alert('VPL: filesChanged() javascript error');
	}
	try{
		if(vpl_NFiles != ae.getNFiles()){
			return true;
		}
		if(fm.elements['filename'] != null){
			newData = new String(ae.getFileContent(0));
			return newData.valueOf() != vpl_fileData[0].valueOf();
		}
		for(i=0; i<vpl_NFiles; i++){
			newName = new String(ae.getFileName(i));
			previousName = vpl_fileName[i];
			newData = new String(ae.getFileContent(i));
			previousData = vpl_fileData[i];
			if(newName.valueOf() != previousName.valueOf() ||
				previousData.valueOf() != newData.valueOf()){
				return true;
			}
		}
		return false;
	}
	catch(e){ //No access to applet
		alert('VPL: error no access to applet');
		return false;
	}
}

/**
* This function alert if files in editor has change
*/
function vpl_alertFilesChanged(){
	if(vpl_filesChanged()){
		alert(vpl_filesChangedNotSaved);
	}
	return true;
}

/**
* This function start acction if files changed or not changed
*/
function vpl_action(action,save){
	vpl_setETarget();
	res = true;
	if(save){
		res = vpl_readFiles();
	}else{
		if(vpl_filesChanged()){
			alert(vpl_filesChangedNotSaved);
		}		
	}
	if(res){
		var applet = window.document.getElementById('appleteditorid');
		applet.startStatusBarProcess(action);
	}
	return res;
}

/**
* This function start acction if files changed or not changed
*/
function vpl_action1(action){
	vpl_setETarget();
	if(vpl_filesChanged()){
		alert(vpl_filesChangedNotSaved);
	}
	var applet = window.document.getElementById('appleteditorid');
	applet.startStatusBarProcess(action);
	return true;
}

/**
* This function install the checker to alert if going to leave the page
* and files has changed 
*/
function vpl_installCloseCheck(){
	window.onbeforeunload= function(){
		if(vpl_filesChanged(vpl_maxFiles)){
			return vpl_changesNotSaved;
		}
	}
}

/**
* This function resize the applet to greatest visible size 
*/
var vpl_appletWidth=0;
var vpl_appletHeight=0;

function vpl_resizeApplet(){
	window.onresize=null; // Avoid continuous resize
	var pageObject= window.document.getElementById('page');
	var appletObject=window.document.getElementById('appleteditorid');
	var appletDiv=window.document.getElementById('appletdivid');
	if(pageObject != null && appletObject != null){
		try{
			var diffHeight=0;
			pageRec = pageObject.getBoundingClientRect();
			appletRec = appletDiv.getBoundingClientRect();
			diffHeight=(pageRec.bottom-pageRec.top)-(appletRec.bottom-appletRec.top);
			var diffHeight=(pageRec.bottom-pageRec.top)-(appletRec.bottom-appletRec.top);
			var newWidth=document.documentElement.clientWidth-2*appletRec.left;
			var newHeight=document.documentElement.clientHeight-diffHeight;
			if(vpl_appletWidth!= newWidth || vpl_appletHeight != newHeight){
				vpl_appletWidth= newWidth;
				vpl_appletHeight= newHeight;
				appletObject.setSize(newWidth,newHeight);
				appletDiv.style.width = newWidth+"px";
				appletDiv.style.height  = newHeight+"px";
			}
		}
		catch(e){ //No access to applet
			// Do nothing
		}
	}
	window.onresize=vpl_resizeApplet;
}


/**
* This function init editor page
*/
function vpl_init_editor_page(){
	vpl_installCloseCheck();
	window.onresize=vpl_resizeApplet;
	vpl_resizeApplet();
	var fm = window.document.getElementById('mform1');
	var er= window.document.getElementById('div_er');
	if(er == null || fm == null){
		alert('VPL: setETarget() javascript error');
		throw 'VPL: setETarget() javascript error'; 
	}
	fm.target='edit_result';
	er.innerHTML='<iframe name="edit_result"></iframe>';	
}

/**
* This set the resize controler
*/
window.onresize=vpl_resizeApplet;

