<?php
/**
 * @version		$Id: similarity_factory.class.php,v 1.5 2011-06-12 13:40:25 juanca Exp $
 * @package		vpl. Similarity object factory clases
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

class vpl_filetype{
	//TODO implement new types
	static private $sstr = array(
						'h'=>'cpp',
						'hxx'=>'cpp',
						'c'=>'c',
						'C'=>'cpp',
						'cpp'=>'cpp',
						'ads'=>'ada',
						'adb'=>'ada',
						'ada'=>'ada',
						'java'=>'java',
						'Java'=>'java',
						'scm'=>'scheme',
						'pl' =>'prolog'
	);
	static public function str($ext){
		if(isset(self::$sstr[$ext])){
			return self::$sstr[$ext];
		}else{
			return false;
		}
	}
}

class vpl_similarity_factory{
	static private $classloaded=array();
	static private function get_object($type){
		if(!isset($classloaded[$type])){
			$include = 'similarity_'.$type.'.class.php';
			require_once($include);
			$classloaded[$type]=true;
		}
		$class = 'vpl_similarity_'.$type;
		return new $class();
	}

	static public function get($filename){
		$ext = pathinfo($filename,PATHINFO_EXTENSION);
		if($type=vpl_filetype::str($ext)){
			return self::get_object($type);
		}
		else{
			return null;
		}
	}
}
?>